<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { ref, computed, inject } from 'vue';
import { useMetaStore } from '@/stores/meta';
import Modal from "@/components/general/Modal.vue";
import CheckBox from '@/components/general/form/Checkbox.vue';
import { request } from '@/lib/request';
import { adminMenuEnum } from '@/enums/enums';

const { t } = useI18n();
const $t = t;

const store = useMetaStore();
let configuration = inject<any>('configuration');

const { paneType, hashcode, getCommentsAllowed: hasComments, getHeadline: hasLikes, openMenu } = storeToRefs(store);

const shareDate = ref(null);
const copyLikes = ref(true);
const copyComments = ref(true);
const existingShare = ref(false);
const shareHashcode = ref('');

const emits = defineEmits<{
    (e: 'close', value: boolean): void
}>();

const fetchShareData = async () => {
    let result = await request('GET', configuration.apiServer + '/api/' + paneType.value + '/share/' + hashcode.value, undefined, 'application/json', false, true);
    if (result && result.success) {
        shareHashcode.value = result.hashcode;
        existingShare.value = true;
    }
}

fetchShareData();

const shareDateCalc = (date: any, days: number) => {
    var result = new Date(date);
    result.setHours(23, 59, 59, 999);
    result.setDate(result.getDate() + days);
    return {
        timestamp: Date.parse(String(result)),
        displayDate: result.toLocaleDateString(),
    };
}

const shareDates = [shareDateCalc(new Date(), 1), shareDateCalc(new Date(), 3), shareDateCalc(new Date(), 7)];

const getPrevURL = computed(() => {
    return configuration.baseURL + configuration.basePath + 'p/' + shareHashcode.value;
})

const endSharePane = async () => {
    let result = await request('DELETE', configuration.apiServer + '/api/' + paneType.value + '/share/', { hashcode: hashcode.value }, 'application/json', false, true);
    if (result && result.success) {
        existingShare.value = false;
    }
}

const submit = async () => {
    if (existingShare.value) {
        cancel();
    } else {
        let result = await request('POST', configuration.apiServer + '/api/' + paneType.value + '/share/',
            { hashcode: hashcode.value, copyLikes: copyLikes.value, copyComments: copyComments.value, shareDate: shareDate.value }, 'application/json', false, true);
        if (result && result.success) {
            shareHashcode.value = result.hashcode;
            existingShare.value = true;
        }
    }
}

const cancel = () => {
    existingShare.value = false;
    shareHashcode.value = '';
    shareDate.value = null;
    copyLikes.value = true;
    copyComments.value = true;
    openMenu.value = adminMenuEnum.NONE;
}

</script>
<template>
    <Modal :header="$t('adminMenu.copy.forOthers.share.title')" @cancel="cancel" :afterSubmitClose="false"
        :labelCancel="existingShare ? undefined : $t('general.buttons.cancel')"
        :labelSubmit="existingShare ? $t('general.buttons.close') : $t('general.buttons.send')"
        :disableSubmit="existingShare ? false : !shareDate" @submit="submit">
        <div v-if="existingShare" class="flex flex-row gap-2">
            <div class="w-1/4 h-9 flex items-center">
                <CheckBox v-model="existingShare" :label="$t('adminMenu.copy.forOthers.share.label')"
                    @click="endSharePane" />
            </div>
            <div class="grow h-9 leading-4 flex items-center">
                <a class="break-all text-blue-900 hover:text-blue-950 underline" :href="getPrevURL" target="_blank"
                    rel="opener">{{ getPrevURL }}</a>
            </div>
        </div>
        <div v-else>
            <div>
                <select
                    class="w-full border border-gray-300 px-2 py-1.5 focus:border-accent1-default rounded-md focus-visible:outline-0"
                    v-model="shareDate">
                    <option disabled :value="null">{{ $t('adminMenu.copy.forOthers.valid') }}</option>
                    <option v-for="date in shareDates" :value="date.timestamp">{{ date.displayDate }}</option>
                </select>
            </div>
            <div class="mt-2" v-if="hasComments || hasLikes">
                <div class="flex flex-row gap-2">
                    <div class="w-1/2" v-if="hasLikes">
                        <CheckBox v-model="copyLikes" :label="$t('adminMenu.copy.forOthers.share.likes')" />
                    </div>
                    <div v-if="hasComments">
                        <CheckBox v-model="copyComments" :label="$t('adminMenu.copy.forOthers.share.comments')" />
                    </div>
                </div>
            </div>
        </div>
    </Modal>
</template>